;; vcs ver 3

;; - 56k2 hardware equates

abcr            equ     $fffe           ;Bus Control Register
apll	        equ     $fffd           ;PLL Control Register

aipr		equ	$ffff		;interrupt priority register
apcc		equ	$ffe1		;port c control register
apbc             equ     $ffe0           ;port b control register

; sci equates
ascr             equ     $fff0           ;sci control register
asccr            equ     $fff2           ;sci clock control register
assr             equ     $fff1           ;sci status register
astxl            equ     $fff4           ;sci tx low
asrxl            equ     $fff4           ;sci rx low
asrxh            equ     $fff6
atdre            equ     1               ;transmit data register empty flag
ardrf            equ     2               ;receive data register full flag

SCIBAUD         equ     $00f

;#$0c - 4800
;#$40 - 9600
;#$20 - 19200
;#$00f - 38.4k
;#$00a - 56k

;; Version control
VER             equ     1
EXT             equ     0
;; Constants
TRUEE           equ     -1
TRUE            equ     -1
FALSE           equ      0

COMPO           equ     $040
IMEDD           equ     $080
MASKK           equ     $7f7f1f
CELLL           equ     1

BASEE           equ     10
MEMSPC          equ     'X'
VOCSS           equ     8

BKSPP           equ     8
LF              equ     10
CRR             equ     13
ERR             equ     27
TIC             equ     39

;CALLL           equ     $0AF080
CALLL           equ     $0c0000

;; Memory allocation

EM              equ     $6fff
US              equ     64*CELLL
RTS             equ     128*CELLL
UPP             equ     EM-US
RPP             equ     UPP-8*CELLL
TIBB            equ     RPP-RTS
SPP             equ     TIBB-8*CELLL

COLDD           equ     $0800
COLD56          equ     $0900

RESET           EQU     $E000

CODEE           equ     COLD56+US
NAMEE           equ     EM-$0400

;; Initialize assembly variables

LINKp   = 0

NAMEp   = NAMEE
CODEp   = CODEE
USERp   = 4*CELLL
LEN	= 0


        if prnmsgs==1
        msg    "EM",'  ',EM
        msg    "US",'  ',US
        msg    "RTS",'  ',RTS
        msg    "UPP",'  ',UPP
        msg    "RPP",'  ',RPP
        msg    "TIBB",'  ',TIBB
        msg    "SPP",'  ',SPP
        msg    "COLDD",'  ',COLDD
        msg    "COLDD",'  ',COLDD
        msg    "COLD56",'  ',COLD56
        msg    "CODEE",'  ',CODEE
        msg    "NAMEE",'  ',NAMEE
        endif