;; vcs ver 3

        ORG     p:CODEE         ; beginning of the code dictionary


;; Device dependent I/O


;; -   BYE         ( -- )
;		Exit eForth.

		CODE	3,BYE,BYE
		jmp	*

;echo
		CODE	4,ECHO,ECHO
		clr	a
                move    x:(r7)+,a
		tst	a
		jeq	echo1
		jclr	#atdre,x:assr,*	;wait for sci to be ready
                move    x:(r7)+,x0
                movep   x0,x:astxl       ;transmit data
echo1		NEXT


;; -   ?RX         ( -- c T | F )
;		Return input character and true, or a false if no input.

		CODE	3,?RX,QRX
		move	#FALSE,x0
		jclr	#ardrf,x:assr,qrx2  	;see if data in dsp sci
 		movep	x:asrxl,x:-(r7)
		move	#TRUE,x0
qrx2  		move	x0,x:-(r7)

		NEXT

;; -   TX!         ( c -- )
;	 	Send character c to the output device.

		CODE	3,TX!,TXSTO

		jclr	#atdre,x:assr,*	;wait for sci to be ready
		move 	x:(r7)+,x0
		movep	x0,x:astxl	;transmit data


		NEXT

;; -   !IO         ( -- )
;		Initialize the serial I/O devices.

		CODE	3,!IO,STOIO
		movep   #$03,x:apcc      ; set CC(2:0), sci on
		movep	#0,x:ascr        ;zero the control register
		movep	#0,x:asccr       ;zero the clock control register
		bset	#1,x:ascr        ;Set it for 10 bits
        	bset    #9,x:ascr        ; enable the transmitter
        	bset    #8,x:ascr        ; enable the receiver

		move 	x:(r7)+,a1	; set baud
		movep	a1,x:asccr
		NEXT


;; The kernel
;; -    doLIT       ( -- w )
;		Push an inline literal.

		CODE	COMPO+5,doLIT,DOLIT

;                jsr     dbug

                move    p:(r5)+,x0      ; push (IP) on stack, inc IP
		move	x0,x:-(r7)
		NEXT


;; -    doLIST      ( a -- )
;		Process colon list.
		CODE	COMPO+6,doLIST,DOLST

                move    r5,x:-(r6)              ; push IP (next token) on RP
                 move    (r4)+

                ; if COLD > 900h then need another move (r4)+
                ; due to jmp instruction taking two p words
 ;               move    (r4)+

                move    r4,r5                   ; copy next token into IP
                nop

doL1            move    p:(r5)+,r4              ; NEXT
                nop
doL2           	jmp     (r4)


;; -    next        ( -- )
;		Run time code for the single index loop.
;		: next ( -- ) \ hilevel model
;		  r> r> dup if 1 - >r @ >r exit then drop cell+ >r ;

		CODE	COMPO+4,next,DONXT

                clr     a
		move	x:(r6),a		; loop index on RP
		tst	a
		jne	nex1			; 0?
		move	x:(r6)+,a		; yes, pop RP
                move    p:(r5)+,a               ; inc IP
		NEXT

nex1            move    #>1,x0                  ; NO, dec and exit
		sub	x0,a
		move	a,x:(r6)
                move    p:(r5),r5               ;IP:=(IP)
                NEXT


;; -    ?branch     ( f -- )
;		Branch if flag is zero.

		CODE	COMPO+7,?branch,QBRAN

		clr	a
		move	x:(r7)+,a
		tst	a
		jne	qbr2			; FALSE?
                move    p:(r5),r5               ;IP:=(IP)
		NEXT

qbr2            move    p:(r5)+,a1              ; TRUE? IP++ (to next token)
		NEXT

;; -    branch      ( -- )
;		Branch to an inline address.

		CODE	COMPO+6,branch,BRAN
                move    p:(r5),r5               ;IP:=(IP)
		nop
		NEXT

;; -    EXECUTE     ( ca -- )
;		Execute the word at ca.

		CODE	7,EXECUTE,EXECU

EX1             move    x:(r7)+,r4
		nop
		jmp	(r4)

;; -    EXIT        ( -- )
;		Terminate a colon definition.

		CODE	4,EXIT,EXIT
		move	x:(r6)+,r5

                nop
                move    p:(r5)+,r4              ; NEXT
                nop
EXIT1           jmp    (r4)


;; -    !           ( w a -- )
;		Pop the data stack to memory.

		CODE	1,!,STORE
		move	x:(r7)+,r0	; pop addr into r0
		move	x:(r7)+,x0	; pop data into x0
		move	x0,x:(r0)	; store x0 into (r0)
		NEXT

;; -    @           ( a -- w )
;		Push memory location to the data stack.

		CODE	1,@,AT
		move	x:(r7)+,r0	; pop stack addr data into x0
		nop
		move	x:(r0),x0
		move	x0,x:-(r7)	; push data back on stack
		NEXT

;; -    X@           ( a -- w )
;               Push X memory location to the data stack.

                CODE    2,X@,XAT
		move	x:(r7)+,r0	; pop stack addr data into x0
		nop
		move	x:(r0),x0
		move	x0,x:-(r7)	; push data back on stack
		NEXT


;; -    Y@           ( a -- w )
;               Push Y memory location to the data stack.

                CODE    2,Y@,YAT
		move	x:(r7)+,r0	; pop stack addr data into x0
		nop
                move    y:(r0),x0
		move	x0,x:-(r7)	; push data back on stack
		NEXT

;; -    P@           ( a -- w )
;               Push P memory location to the data stack.

                CODE    2,P@,PAT
		move	x:(r7)+,r0	; pop stack addr data into x0
		nop
                move    p:(r0),x0
		move	x0,x:-(r7)	; push data back on stack
		NEXT



;; -    C!          ( c b -- )
;		Pop the data stack to byte memory.

		CODE	2,C!,CSTOR
		move	x:(r7)+,r0	; pop sp addr into r0
		clr	a
		move	x:(r7)+,a0	; pop sp -> a0
		move	#$FF,x0
		and	x0,a
 		move	a0,x:(r0)	; store in addr
		NEXT

;; -    C@          ( b -- c )
;		Push byte memory location to the data stack.

		CODE	2,C@,CAT
		move	x:(r7)+,r0	; pop stack addr data into x0
		clr	a
		move	x:(r0),a0
		move	#$FF,x0
		and	x0,a
		move	a0,x:-(r7)	; push data byte on stack
		NEXT

;; -    RP@         ( -- a )
;		Push the current RP to the data stack.

		CODE	3,RP@,RPAT
		move	r6,x:-(r7)	; push rp onto sp
		NEXT


;; -    RP!         ( a -- )
;		Set the return stack pointer.

		CODE	COMPO+3,RP!,RPSTO
		move	x:(r7)+,r6
		NEXT

;; -    R>          ( -- w )
;		Pop the return stack to the data stack.

		CODE	COMPO+2,R>,RFROM
		move	x:(r6)+,x0       ; pop rp addr
		move	x0,x:-(r7)	; push onto sp
		NEXT

;; -    R@          ( -- w )
;		Copy top of return stack to the data stack.

		CODE	2,R@,RAT
                move    x:(r6),x0       ; copy rp addr contents
		move	x0,x:-(r7)	; push onto sp
		NEXT

;; -    >R          ( w -- )
;		Push the data stack to the return stack.

		CODE	COMPO+2,'>R',TOR
		move	x:(r7)+,x0       ; pop rp addr
		move	x0,x:-(r6)	; push onto sp
		NEXT

;; -    SP@         ( -- a )
;		Push the current data stack pointer.

		CODE	3,SP@,SPAT
		move	r7,x0
		move	x0,x:-(r7)
		NEXT

;; -    SP!         ( a -- )
;		Set the data stack pointer.

		CODE	3,SP!,SPSTO
		move	x:(r7)+,x0
		move	x0,r7
		NEXT

;; -    IP@         ( -- a )
;               Push the current interpreter pointer.

                CODE    3,IP@,IPAT
                move    r5,x:-(r7)
		NEXT

;; -    IP!         ( -- a )
;               Set the interpreter pointer

                CODE    3,IP!,IPSTO
                move    x:(r7)+,r5
                NEXT


;; -    DROP        ( w -- )
;		Discard top stack item.

		CODE	4,DROP,DROP
		move	x:(r7)+,x0
		NEXT

;; -    DUP         ( w -- w w )
;		Duplicate the top stack item.

		CODE	3,DUP,DUPP
		move	x:(r7),x0
		move	x0,x:-(r7)
		NEXT

;; -    SWAP        ( w1 w2 -- w2 w1 )
;		Exchange top two stack items.

		CODE	4,SWAP,SWAP
		move	x:(r7)+,x0
		move	x:(r7)-,x1
		move	x1,x:(r7)+
		move	x0,x:(r7)-
		NEXT

;; -    OVER        ( w1 w2 -- w1 w2 w1 )
;		Copy second stack item to top.

		CODE	4,OVER,OVER
		move	x:(r7)+,x0	; resolve - inc r7 to w1
		move	x:(r7)-,x0	; resolve - dec r7 to w2
		move	x0,x:-(r7)
		NEXT

;; -    0<          ( n -- t )
;		Return true if n is negative.

		CODE	2,0<,ZLESS

		clr	a
		move	x:(r7)+,a0
                move    #>0,x0
		rep	#23
		asr	a
		tst	a
                cmp     x0,a
                jgt     zless1                  ; less than 0?
                move    #FALSE,x0
		move	x0,x:-(r7)
                NEXT

zless1          move   #TRUE,x0
                move   x0,x:-(r7)
                NEXT


;; -    AND         ( w w -- w )
;		Bitwise AND.

		CODE	3,AND,ANDD

		move	x:(r7)+,x0
		move	x:(r7)+,a1
		and	x0,a1
		move	a1,x:-(r7)
		NEXT


;; -    OR          ( w w -- w )
;		Bitwise inclusive OR.

		CODE	2,OR,ORR
		move	x:(r7)+,x0
		move	x:(r7)+,a1
		or	x0,a1
		move	a1,x:-(r7)
		NEXT

;; -    XOR         ( w w -- w )
;		Bitwise exclusive OR.

		CODE	3,XOR,XORR
		move	x:(r7)+,x0
		move	x:(r7)+,a1
		eor	x0,a1
		move	a1,x:-(r7)
		NEXT



;; -    UM+         ( u u -- udsum )
;		Add two unsigned single numbers and return a double sum.

		CODE	3,UM+,UPLUS

                and     #$fe,ccr                ;clear carry
		clr	a  x:(r7)+,x0
		move	x:(r7)+,a1

		add	x0,a
		move	sr,b1			; get carry
                move    #>1,x0
                and     x0,b a1,x:-(r7)         ; push result
		move	b1,x:-(r7)		; push carry


                NEXT



;; - input registers


;; -    X0@         ( -- a )
;               Push contents of X0 to stack

                CODE    3,X0@,X0AT
                move    X0,x:-(r7)
		NEXT


;; -    X1@         ( -- a )
;               Push contents of X1 to stack

                CODE    3,X1@,X1AT
                move    X1,x:-(r7)
		NEXT

;; -    X1!         ( a -- )
;               push stack to X1

                CODE    3,X1!,X1STO
                move    x:(r7)+,X1
		NEXT

;; -    X0!         ( a -- )
;               push stack to X1

                CODE    3,X0!,X0STO
                move    x:(r7)+,X0
		NEXT




;; -    Y1@         ( -- a )
;               Push contents of Y1 to stack

                CODE    3,Y1@,Y1AT
                move    Y1,x:-(r7)
		NEXT

;; -    Y0@         ( -- a )
;               Push contents of Y0 to stack

                CODE    3,Y0@,Y0AT
                move    Y0,x:-(r7)
		NEXT

;; -    Y1!         ( a -- )
;               push stack to Y1

                CODE    3,Y1!,Y1STO
                move    x:(r7)+,Y1
		NEXT

;; -    Y0!         ( a -- )
;               push stack to Y1

                CODE    3,Y0!,Y0STO
                move    x:(r7)+,Y0
		NEXT



;; - accumlators

;; -    A0@         ( -- a )
;               Push contents of A0 to stack

                CODE    3,A0@,A0AT
                move    A0,x:-(r7)
		NEXT

;; -    A1@         ( -- a )
;               Push contents of A1 to stack

                CODE    3,A1@,A1AT
                move    A1,x:-(r7)
		NEXT


;; -    A2@         ( -- a )
;               Push contents of A1 to stack

                CODE    3,A2@,A2AT
                move    A2,x:-(r7)
		NEXT

;; -    A0!         ( a -- )
;               push stack to A0

                CODE    3,A0!,A0STO
                move    x:(r7)+,A0
		NEXT




;; -    A1!         ( a -- )
;               push stack to A1

                CODE    3,A1!,A1STO
                move    x:(r7)+,A1
		NEXT

;; -    A2!         ( a -- )
;               push stack to A2

                CODE    3,A2!,A2STO
                move    x:(r7)+,A2
		NEXT




;; -    B0@         ( -- a )
;               Push contents of B0 to stack

                CODE    3,B0@,B0AT
                move    B0,x:-(r7)
		NEXT

;; -    B1@         ( -- a )
;               Push contents of B1 to stack

                CODE    3,B1@,B1AT
                move    B1,x:-(r7)
		NEXT

;; -    B2@         ( -- a )
;               Push contents of A1 to stack

                CODE    3,B2@,B2AT
                move    B2,x:-(r7)
		NEXT



;; -    B0!         ( a -- )
;               push stack to B0

                CODE    3,B0!,B0STO
                move    x:(r7)+,B0
		NEXT


;; -    B1!         ( a -- )
;               push stack to B1

                CODE    3,B1!,B1STO
                move    x:(r7)+,B1
		NEXT

;; -    B2!         ( a -- )
;               push stack to B2

                CODE    3,B2!,B2STO
                move    x:(r7)+,B2
		NEXT



;; - address registers      these should be an option since
;                           total code bloat for reg prims will be > 1K words


;; -    R0@          ( -- w )
;               Copy contents of R0 to the data stack.

                CODE    3,R0@,R0AT
                move    R0,x:-(r7)      ; push onto sp
		NEXT

;; -    R0!          ( -- w )
;               push data stack to R0

                CODE    3,R0!,R0STO
                move    x:(r7)+,R0
		NEXT


;; -    R0X@          ( -- w )
;               push contents of addr in R0 x:space to data stack

                CODE    4,R0X@,R0XAT
                move    x:(R0),X0
                move    X0,x:-(r7)
		NEXT

;; -    R0Y@         ( -- w )
;               push contents of addr in R0 y:space to data stack

                CODE    4,R0Y@,R0YAT
                move    y:(R0),X0
                move    X0,x:-(r7)
		NEXT

;; -    R0P@          ( -- w )
;               push contents of addr in R0 p:space to data stack

                CODE    4,R0P@,R0PAT
                move    p:(R0),X0
                move    X0,x:-(r7)
		NEXT



;; -    R0X!          ( -- w )
;               push data stack to address pointed to be R0

                CODE    4,R0X!,R0XSTO
                move    x:(r7)+,X0
                move    X0,x:(R0)
		NEXT

;; -    R0Y!          ( -- w )
;               push data stack to address pointed to be R0

                CODE    4,R0Y!,R0YSTO
                move    x:(r7)+,X0
                move    X0,y:(R0)
		NEXT

;; -    R0P!          ( -- w )
;               push data stack to address pointed to be R0

                CODE    4,R0P!,R0PSTO
                move    x:(r7)+,X0
                move    X0,p:(R0)
		NEXT

;; !! for n and m regs will probably only need store prims

;; -    N1!          ( -- w )
;               push data stack to n0

                CODE    3,N0!,N0STO
                move    x:(r7)+,n1
		NEXT

;; -    M1!          ( -- w )
;               push data stack to m0

                CODE    3,M0!,M0STO
                move    x:(r7)+,m1
		NEXT






;; -    R1@          ( -- w )
;               Copy contents of R1 to the data stack.

                CODE    3,R1@,R1AT
                move    R1,x:-(r7)      ; push onto sp
		NEXT

;; -    R1!          ( -- w )
;               push data stack to R1

                CODE    3,R1!,R1STO
                move    x:(r7)+,R1
		NEXT


;; -    R1X@          ( -- w )
;               push contents of addr in R1 x:space to data stack

                CODE    4,R1X@,R1XAT
                move    x:(R1),X0
                move    X0,x:-(r7)
		NEXT

;; -    R1Y@         ( -- w )
;               push contents of addr in R1 y:space to data stack

                CODE    4,R1Y@,R1YAT
                move    y:(R1),X0
                move    X0,x:-(r7)
		NEXT

;; -    R1P@          ( -- w )
;               push contents of addr in R1 p:space to data stack

                CODE    4,R1P@,R1PAT
                move    p:(R1),X0
                move    X0,x:-(r7)
		NEXT



;; -    R1X!          ( -- w )
;               push data stack to address pointed to be R1

                CODE    4,R1X!,R1XSTO
                move    x:(r7)+,X0
                move    X0,x:(R1)
		NEXT

;; -    R1Y!          ( -- w )
;               push data stack to address pointed to be R1

                CODE    4,R1Y!,R1YSTO
                move    x:(r7)+,X0
                move    X0,y:(R1)
		NEXT

;; -    R1P!          ( -- w )
;               push data stack to address pointed to be R1

                CODE    4,R1P!,R1PSTO
                move    x:(r7)+,X0
                move    X0,p:(R1)
		NEXT

;; !! for n and m regs will probably only need store prims

;; -    N1!          ( -- w )
;               push data stack to R1

                CODE    3,N1!,N1STO
                move    x:(r7)+,n1
		NEXT

;; -    M1!          ( -- w )
;               push data stack to R1

                CODE    3,m1!,M1STO
                move    x:(r7)+,m1
		NEXT




;; -    R2@          ( -- w )
;               Copy contents of R2 to the data stack.

                CODE    3,R2@,R2AT
                move    R2,x:-(r7)      ; push onto sp
		NEXT

;; -    R2!          ( -- w )
;               push data stack to R2

                CODE    3,R2!,R2STO
                move    x:(r7)+,R2
		NEXT


;; -    R2@x          ( -- w )
;               push contents of addr in R2 x:space to data stack

                CODE    4,R2X@,R2XAT
                move    x:(R2),X0
                move    X0,x:-(r7)
		NEXT

;; -    R2Y@         ( -- w )
;               push contents of addr in R2 y:space to data stack

                CODE    4,R2Y@,R2YAT
                move    y:(R2),X0
                move    X0,x:-(r7)
		NEXT

;; -    R2P@          ( -- w )
;               push contents of addr in R2 p:space to data stack

                CODE    4,R2P@,R2PAT
                move    p:(R2),X0
                move    X0,x:-(r7)
		NEXT



;; -    R2X!          ( -- w )
;               push data stack to address pointed to be R2

                CODE    4,R2X!,R2XSTO
                move    x:(r7)+,X0
                move    X0,x:(R2)
		NEXT

;; -    R2Y!          ( -- w )
;               push data stack to address pointed to be R2

                CODE    4,R2Y!,R2YSTO
                move    x:(r7)+,X0
                move    X0,y:(R2)
		NEXT

;; -    R2P!          ( -- w )
;               push data stack to address pointed to be R2

                CODE    4,R2P!,R2PSTO
                move    x:(r7)+,X0
                move    X0,p:(R2)
		NEXT

;; !! for n and m regs will probably only need store prims

;; -    N2!          ( -- w )
;               push data stack to n2

                CODE    3,N2!,N2STO
                move    x:(r7)+,n1
		NEXT

;; -    M2!          ( -- w )
;               push data stack to M2

                CODE    3,M2!,M2STO
                move    x:(r7)+,m1
		NEXT


;; -    R3@          ( -- w )
;               Copy contents of R3 to the data stack.

                CODE    3,R3@,R3AT
                move    R3,x:-(r7)      ; push onto sp
		NEXT

;; -    R3!          ( -- w )
;               push data stack to R3

                CODE    3,R3!,R3STO
                move    x:(r7)+,R3
		NEXT


;; -    R3@x          ( -- w )
;               push contents of addr in R3 x:space to data stack

                CODE    4,R3X@,R3XAT
                move    x:(R3),X0
                move    X0,x:-(r7)
		NEXT

;; -    R3Y@         ( -- w )
;               push contents of addr in R3 y:space to data stack

                CODE    4,R3Y@,R3YAT
                move    y:(R3),X0
                move    X0,x:-(r7)
		NEXT

;; -    R3P@          ( -- w )
;               push contents of addr in R3 p:space to data stack

                CODE    4,R3P@,R3PAT
                move    p:(R3),X0
                move    X0,x:-(r7)
		NEXT



;; -    R3X!          ( -- w )
;               push data stack to address pointed to be R3

                CODE    4,R3X!,R3XSTO
                move    x:(r7)+,X0
                move    X0,x:(R3)
		NEXT

;; -    R3Y!          ( -- w )
;               push data stack to address pointed to be R3

                CODE    4,R3Y!,R3YSTO
                move    x:(r7)+,X0
                move    X0,y:(R3)
		NEXT

;; -    R3P!          ( -- w )
;               push data stack to address pointed to be R3

                CODE    4,R3P!,R3PSTO
                move    x:(r7)+,X0
                move    X0,p:(R3)
		NEXT

;; !! for n and m regs will probably only need store prims

;; -    N3!          ( -- w )
;               push data stack to N3

                CODE    3,N3!,N3STO
                move    x:(r7)+,n1
		NEXT

;; -    M3!          ( -- w )
;               push data stack to M3

                CODE    3,M3!,M3STO
                move    x:(r7)+,m1
		NEXT


;; -    R4@          ( -- w )
;               Copy contents of R4 to the data stack.

                CODE    3,R4@,R4AT
                move    R4,x:-(r7)      ; push onto sp
		NEXT

;; -    R4!          ( -- w )
;               push data stack to R4

                CODE    3,R4!,R4STO
                move    x:(r7)+,R4
		NEXT


;; -    R4@x          ( -- w )
;               push contents of addr in R4 x:space to data stack

                CODE    4,R4X@,R4XAT
                move    x:(R4),X0
                move    X0,x:-(r7)
		NEXT

;; -    R4Y@         ( -- w )
;               push contents of addr in R4 y:space to data stack

                CODE    4,R4Y@,R4YAT
                move    y:(R4),X0
                move    X0,x:-(r7)
		NEXT

;; -    R4P@          ( -- w )
;               push contents of addr in R4 p:space to data stack

                CODE    4,R4P@,R4PAT
                move    p:(R4),X0
                move    X0,x:-(r7)
		NEXT



;; -    R4X!          ( -- w )
;               push data stack to address pointed to be R4

                CODE    4,R4X!,R4XSTO
                move    x:(r7)+,X0
                move    X0,x:(R4)
		NEXT

;; -    R4Y!          ( -- w )
;               push data stack to address pointed to be R4

                CODE    4,R4Y!,R4YSTO
                move    x:(r7)+,X0
                move    X0,y:(R4)
		NEXT

;; -    R4P!          ( -- w )
;               push data stack to address pointed to be R4

                CODE    4,R4P!,R4PSTO
                move    x:(r7)+,X0
                move    X0,p:(R4)
		NEXT

;; !! for n and m regs will probably only need store prims

;; -    N4!          ( -- w )
;               push data stack to n4

                CODE    3,N4!,N4STO
                move    x:(r7)+,n1
		NEXT

;; -    M4!          ( -- w )
;               push data stack to rm

                CODE    3,M4!,M4STO
                move    x:(r7)+,m1
		NEXT

;==============		end of primitives	==========================